#pragma once
#include <cv.h> 
#include <highgui.h> 

// όFhttp://opencv.jp/opencv2-x-samples/2d_dft_idft

using namespace cv;
using namespace std;

// class declaration 
class DftIdftApp {
public:
	DftIdftApp(){};
	DftIdftApp(const int w, const int h);
	virtual ~DftIdftApp(){};
	// 
	void init(const int w, const int h);
	// DFT̎sigpj
	void calcDFT();
	// IDFT̎s
	void calcIDFT(bool all = false);
	void clear(){ idft_img.setTo(0); }
	// DFTO/̎/f[^̎擾
	void getValue(const bool isBefore, const int row, const int col, double *re, double *im);
	// DFTO/̎/f[^̐ݒ
	void setValue(const bool isBefore, const int row, const int col, const double re, const double im);
	// 摜̕ۑifobNpj
	void saveImage(const char *filename);
	// s͗l̍폜iAChoppyA@pjBĩNX̃o֐ƂĂ͕sK؁j
	void invertHeight();
	void invertChoppy(const double chop);
	void invertNormal(float *maxVal);

public:
	Mat src_img, idft_img;
	Mat Ref_img, Imf_img, ReF_img, ImF_img, Complex_img;
	Mat zero, dft_src, dft_dst, dft_dst_p;
	vector<Mat> mvf, mvF;
	int src_cols, src_rows, dft_cols, dft_rows;
};