#pragma once
#include "DftIDftApp.h"

class OceanTest
{
public:
	OceanTest();
	virtual ~OceanTest();

	int Lx, Lz, M, N;
	float wind[3];
	float V, A, chop;
	float *omega, *h0ReF, *h0ImF;
	float *position, *normal;
	unsigned int *indices;
	int vertexNum, faceNum, indexNum;

	// dftp, normalchoppyxẑQKv
	DftIdftApp height, normalDft[2], choppy[2];

	// 
	void init(const int lx, const int lz, const int m, const int n, const float v, const float a, const float w[2]);
	// I
	void release();
	// ƂȂf[^̌vZ
	void calculateBaseHeight();
	// XyNǧvZ
	double PhillipsSpectrum(const double k[2]);
	// ̌vZ
	void calculateHeight(const double t, const int normalMethod, const float yScale=0.08f);
	// Choppy WavěvZ
	void calculateChoppyWave();
	// \p|S̍쐬
	void createMesh(const float scale[3], const float offset[3], const float chopScale);
	// g̍XV
	void updateHeight(const double t, const float scale[3], const float offset[3], const float choppy, const int normalMethod, const float yScale = 0.08f);
	// @xNǧvZP
	void calculateNormals(const float yScale);
	// @xNǧvZQ
	void normalsFiniteDifferences(const float yScale);
};

